# NOTE: shared /%{_lib}/libtcmalloc* is useless without /usr/%{_lib}/libstdc++.so.6, move back to /usr?
# TODO:
# - subpackages for "minimal" and the rest?

# Conditional build:
%bcond_with	minimal		# build only build only tcmalloc-minimal
%bcond_without	libunwind	# libunwind for backtraces (esp. without frame info)

%ifnarch %{ix86} %{x8664} x32 ia64
%undefine	with_libunwind
%endif

Summary:	Fast, multi-threaded malloc and performance analysis tools
Summary(pl.UTF-8):	Szybka, wielowątkowa implementacja malloc i narzędzia do analizy wydajności
Name:		gperftools
Version:	2.15
Release:	1%{?tld}
License:	BSD
Group:		Libraries
# Source0Download: https://github.com/gperftools/gperftools/releases
Source0:	https://github.com/gperftools/gperftools/releases/download/%{name}-%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	0c16898d428c6f2694c1ea9e6525de8f
URL:		https://github.com/gperftools/gperftools
BuildRequires:	libstdc++-devel >= 6:4.7
%{?with_libunwind:BuildRequires:	libunwind-devel >= 0.98.6}
BuildRequires:	sed >= 4.0
Requires:	libtcmalloc = %{version}-%{release}
Obsoletes:	google-perftools < 2.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Perf Tools is a collection of performance analysis tools, including a
high-performance multi-threaded malloc() implementation that works
particularly well with threads and STL, a thread-friendly
heap-checker, a heap profiler, and a cpu-profiler.

%description -l pl.UTF-8
Perf Tools to zbiór narzędzi do analizy wydajności, zawierający także
bardzo wydajną, wielowątkową implementację malloc(), działającą dobrze
w szczególności z wątkami i STL-em, a także przyjazne wątkom narzędzie
do kontroli sterty, profilter sterty oraz profile wykorzystania CPU.

%package devel
Summary:	Development files of perftools libraries
Summary(pl.UTF-8):	Pliki programistyczne bibliotek perftools
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	libtcmalloc-devel = %{version}-%{release}
Obsoletes:	google-perftools-devel < 2.0

%description devel
The google-perftools-devel package contains the header files needed to
develop applications with google-perftools libraries.

%description devel -l pl.UTF-8
Ten pakiet zawiera pliki nagłówkowe niezbędne do tworzenia aplikacji z
użyciem bibliotek google-perftools.

%package static
Summary:	Static perftools libraries
Summary(pl.UTF-8):	Statyczne biblioteki perftools
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}
Obsoletes:	google-perftools-static < 2.0

%description static
The google-perftools-static package contains the static libraries of
google-perftools.

%description static -l pl.UTF-8
Ten pakiet zawiera biblioteki statyczne google-perftools.

%package -n libtcmalloc
Summary:	Fast, multi-threaded malloc by Google
Summary(pl.UTF-8):	Szybka, wielowątkowa implementacja malloc firmy Google
Group:		Libraries
Conflicts:	google-perftools < 1.8.3-3

%description -n libtcmalloc
Fast, multi-threaded malloc by Google.

%description -n libtcmalloc -l pl.UTF-8
Szybka, wielowątkowa implementacja malloc firmy Google.

%package -n libtcmalloc-devel
Summary:	Fast, multi-threaded malloc by Google - header files
Summary(pl.UTF-8):	Szybka, wielowątkowa implementacja malloc firmy Google - pliki nagłówkowe
Group:		Development/Libraries
Requires:	libstdc++-devel >= 6:4.7
Requires:	libtcmalloc = %{version}-%{release}
%{?with_libunwind:Requires:	libunwind-devel >= 0.98.6}

%description -n libtcmalloc-devel
Fast, multi-threaded malloc by Google - header files.

%description -n libtcmalloc-devel -l pl.UTF-8
Szybka, wielowątkowa implementacja malloc firmy Google - pliki
nagłówkowe.

%package -n libtcmalloc-static
Summary:	Fast, multi-threaded malloc by Google - static libraries
Summary(pl.UTF-8):	Szybka, wielowątkowa implementacja malloc firmy Google - biblioteki statyczne
Group:		Development/Libraries
Requires:	libtcmalloc-devel = %{version}-%{release}

%description -n libtcmalloc-static
Fast, multi-threaded malloc by Google - static libraries.

%description -n libtcmalloc-static -l pl.UTF-8
Szybka, wielowątkowa implementacja malloc firmy Google - biblioteki
statyczne.

%prep
%setup -q

%{__sed} -i -e '1s,/usr/bin/env perl,%{__perl},' pprof-symbolize src/pprof

%build
%configure \
	%{!?with_libunwind:--disable-libunwind} \
	%{?with_minimal:--enable-minimal}

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/%{_lib}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

for pkg in %{!?with_minimal:libtcmalloc} libtcmalloc_minimal; do
	%{__mv} $RPM_BUILD_ROOT%{_libdir}/${pkg}.so.* \
		$RPM_BUILD_ROOT/%{_lib}
	ln -snf /%{_lib}/$(basename $RPM_BUILD_ROOT/%{_lib}/${pkg}.so.*.*.*) \
		$RPM_BUILD_ROOT/%{_libdir}/${pkg}.so
done

%{__rm} $RPM_BUILD_ROOT%{_libdir}/lib*.la

# desired files packaged as %doc
%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post	-n libtcmalloc -p /sbin/ldconfig
%postun	-n libtcmalloc -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
# note: INSTALL contains many perftools-specific notes
%doc AUTHORS COPYING ChangeLog INSTALL NEWS README docs/*.{html,css,png,gif,txt}
%attr(755,root,root) %{_libdir}/libtcmalloc_minimal_debug.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libtcmalloc_minimal_debug.so.4
%if %{without minimal}
%attr(755,root,root) %{_bindir}/pprof
%attr(755,root,root) %{_bindir}/pprof-symbolize
%attr(755,root,root) %{_libdir}/libprofiler.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libprofiler.so.0
%attr(755,root,root) %{_libdir}/libtcmalloc_and_profiler.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libtcmalloc_and_profiler.so.4
%attr(755,root,root) %{_libdir}/libtcmalloc_debug.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libtcmalloc_debug.so.4
%{_mandir}/man1/pprof.1*
%endif

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libtcmalloc_minimal_debug.so
%{_pkgconfigdir}/libtcmalloc_minimal_debug.pc
%if %{without minimal}
%attr(755,root,root) %{_libdir}/libtcmalloc_and_profiler.so
%attr(755,root,root) %{_libdir}/libtcmalloc_debug.so
%attr(755,root,root) %{_libdir}/libprofiler.so
%{_includedir}/google/profiler.h
%{_includedir}/gperftools/profiler.h
%{_pkgconfigdir}/libprofiler.pc
%{_pkgconfigdir}/libtcmalloc_debug.pc
%endif

%files static
%defattr(644,root,root,755)
%{_libdir}/libtcmalloc_minimal_debug.a
%if %{without minimal}
%{_libdir}/libprofiler.a
%{_libdir}/libtcmalloc_and_profiler.a
%{_libdir}/libtcmalloc_debug.a
%endif

%files -n libtcmalloc
%defattr(644,root,root,755)
%attr(755,root,root) /%{_lib}/libtcmalloc_minimal.so.*.*.*
%attr(755,root,root) %ghost /%{_lib}/libtcmalloc_minimal.so.4
%if %{without minimal}
%attr(755,root,root) /%{_lib}/libtcmalloc.so.*.*.*
%attr(755,root,root) %ghost /%{_lib}/libtcmalloc.so.4
%endif

%files -n libtcmalloc-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libtcmalloc_minimal.so
%dir %{_includedir}/google
%{_includedir}/google/malloc_extension*.h
%{_includedir}/google/malloc_hook*.h
%{_includedir}/google/tcmalloc.h
%dir %{_includedir}/gperftools
%{_includedir}/gperftools/malloc_extension*.h
%{_includedir}/gperftools/malloc_hook*.h
%{_includedir}/gperftools/nallocx.h
%{_includedir}/gperftools/tcmalloc.h
%{_pkgconfigdir}/libtcmalloc_minimal.pc
%if %{without minimal}
%attr(755,root,root) %{_libdir}/libtcmalloc.so
%{_includedir}/google/heap-*.h
%{_includedir}/google/stacktrace.h
%{_includedir}/gperftools/heap-*.h
%{_includedir}/gperftools/stacktrace.h
%{_pkgconfigdir}/libtcmalloc.pc
%endif

%files -n libtcmalloc-static
%defattr(644,root,root,755)
%{_libdir}/libtcmalloc_minimal.a
%if %{without minimal}
%{_libdir}/libtcmalloc.a
%endif
%changelog
* Sun Jun 09 2024 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/gperftools.git;a=log;h=master

* Sun May 19 2024 Jakub Bogusz <qboosh@pld-linux.org> 47a3198
- drop .la files

* Sun May 19 2024 Jakub Bogusz <qboosh@pld-linux.org> 853732c
- x32 allows full build now

* Sun May 19 2024 Jakub Bogusz <qboosh@pld-linux.org> 5d9a54d
- fixed build with minimal only

* Sun May 19 2024 Jakub Bogusz <qboosh@pld-linux.org> c28d21c
- updated to 2.15

* Sat Mar 18 2023 Jakub Bogusz <qboosh@pld-linux.org> 32287a7
- updated to 2.10

* Mon Feb 14 2022 Jakub Bogusz <qboosh@pld-linux.org> 08ca182
- updated to 2.9.1

* Sat Mar 30 2019 Jakub Bogusz <qboosh@pld-linux.org> 7e67aa5
- updated to 2.7

* Sun Dec 25 2016 Jakub Bogusz <qboosh@pld-linux.org> 3512a80
- updated to 2.5

* Tue Apr 12 2016 Jakub Bogusz <qboosh@pld-linux.org> 6641e78
- new URLs, updated to 2.4
- fixed libunwind switch, enable on x86 by default (preferred for stacktraces without frame info)

* Mon Jul 27 2015 Elan Ruusamäe <glen@delfi.ee> f3b8073
- %{_includedir}/gperftools dir fix

* Mon Jul 27 2015 Elan Ruusamäe <glen@delfi.ee> 84e51d2
- add minimal bcond, x32 builds with-minimal since 2.0 release

* Sat Aug 24 2013 Jakub Bogusz <qboosh@pld-linux.org> dd6ea56
- updated to 2.1
- removed obsolete glibc216-siginfo_t patch

* Wed Jun 19 2013 Marcin Krol <hawk@tld-linux.org> 182d9fa
- release 2 (by relup.sh)

* Thu Feb 14 2013 Marcin Banasiak <marcin.banasiak@gmail.com> 717c9fd
- Update to 2.0 and rename to gperftools

* Thu Feb 02 2012 Elan Ruusamäe <glen@pld-linux.org> c3be83d
- up to 1.10; new sonames

* Mon Dec 26 2011 Jakub Bogusz <qboosh@pld-linux.org> d576bc9
- updated to 1.9.1

* Tue Nov 22 2011 Jakub Bogusz <qboosh@pld-linux.org> 9c42e86
- pl
- separated libtcmalloc* packages not to require whole analysis packages just for tcmalloc
- note that libtcmalloc in /lib still requires /usr (because of libstdc++ usage)
- avoid using libunwind where not desired
- dropped bogus libao2-devel Obsoletes (copy-pasto?)
- release 3

* Mon Nov 14 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 9b04b22
- rel 2; mv libtcmalloc and libtcmalloc_minimal to /lib{,64}, so these can be used in xfs_repair for example

* Thu Oct 13 2011 Elan Ruusamäe <glen@pld-linux.org> 7c48e00
- up to 1.8.3

* Mon Aug 11 2008 Łukasz Krotowski <lkrotowski@pld-linux.org> 3ec036a
- initial version

